#ifndef _DOCLIST_PDLCOUNT_H
#define _DOCLIST_PDLCOUNT_H

#include <rlcsa/rlcsa.h>

#include "pdltree.h"
#include "utils.h"


using CSA::RLCSA;
using CSA::usint;
using CSA::pair_type;


class PDLCount
{
  public:
    typedef enum { st_unfinished, st_error, st_ok } status_type;

    PDLCount(const RLCSA& _rlcsa, const std::string& base_name, bool _fast);
    ~PDLCount();

    inline bool isOk() const { return (this->status == st_ok); }

    void writeTo(const std::string& base_name) const;
    usint reportSize() const;

    usint count(const std::string& pattern) const;
    usint count(pair_type sa_range) const;

  private:
    const RLCSA&     rlcsa;
    status_type      status;
    bool             fast;

    PDLTree*         tree;
    CSA::Array*      counts;

    // These are not allowed.
    PDLCount();
    PDLCount(const PDLCount&);
    PDLCount& operator = (const PDLCount&);
};


#endif  // _DOCLIST_PDLCOUNT_H
